import requests
import json

def append_known_ip(filename, ip: str):

    f = open(filename, "a")
    f.writelines([ip, "\n"])
    f.close()


def read_known_ips(filename):
    
    f = open(filename, "a+")
    f.close() # tạo file nếu chưa tồn tại
    f = open(filename, "r")
    known_ips = [line.rstrip() for line in f.readlines()]
    f.close()
    return known_ips


def sort_result(filename):
    known_ips = read_known_ips(filename)
    known_ips.sort()
    f = open(filename, "w")
    for ip in known_ips:
        f.writelines([ip, "\n"])
    f.close()


filename = "known_ips.txt"
known_ips = read_known_ips(filename)
count = 100
domain = "ad.doubleclick.net"
while count>0:
    try:
        if(count%100 == 0):
            print("call next 100 request from backward count="+str(count))
        headers = {'accept': 'application/dns-json'}
        r = requests.get("https://1.1.1.1/dns-query?name="+domain, headers=headers)       
        data = json.loads(r.text)
        ip = data['Answer'][0]['data']
        if ip not in known_ips:
            print('found new ip '+ip)
            known_ips.append(ip)
            append_known_ip(filename,ip)

    except:
        pass    
    
    count=count-1

# sắp xếp lại ip theo thứ tự để dễ theo dõi
sort_result(filename)

